package SQ.Blocks.Indicators.ATRPercent;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(APCD) ATR Percent Crosses Below Level", display="ATR Percent Crosses Below Level(@Chart@#ATRPeriod#,#Level#)", returnType = ReturnTypes.Boolean)
@Help("Is triggered if ATR Percent crosses below Level")
@OppositeBlock("ATRPercentCrossDown")
@ParameterSet(set="ATRPeriod=12")
@ParameterSet(set="ATRPeriod=24")
@ParameterSet(set="ATRPeriod=48")
@ParameterSet(set="ATRPeriod=10")
@ParameterSet(set="ATRPeriod=20")
@ParameterSet(set="ATRPeriod=40")
public class ATRPercentCrossDown extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="12", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int ATRPeriod;

	@Parameter(defaultValue="0.1", isPeriod=true, minValue=0, maxValue=1, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		ATRPercent indicator = Strategy.Indicators.ATRPercent(Chart, ATRPeriod);

		double curAtrPValue = indicator.Value.getRounded(Shift,5);
		double prevAtrPValue = indicator.Value.getRounded(Shift+1,5);
		
		return (curAtrPValue < Level)&&(prevAtrPValue > Level);
	}

}