package SQ.Blocks.Indicators.ConnorsRSI;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(CRSIBL) Connors RSI is below Level", display="Connors RSI(@Chart@#RSIPeriod#,#UpDownPeriod#) is below #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if Connors RSI is below Level")
@OppositeBlock(value="CRSIAboveLevel",oscillator=true, middleValue=50,field="Level")
@ParameterSet(set="Level=10")
@ParameterSet(set="Level=20")
@ParameterSet(set="Level=30")
@ParameterSet(set="Level=40")
@ParameterSet(set="Level=50")
@ParameterSet(set="Level=60")
@ParameterSet(set="Level=70")
@ParameterSet(set="Level=80")
@ParameterSet(set="Level=90")
public class CRSIBelowLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="3", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int RSIPeriod;

	@Parameter(defaultValue="2", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int UpDownPeriod;

	@Parameter(defaultValue="50", minValue=0, maxValue=100, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		CRSI indicator = Strategy.Indicators.CRSI(Chart,RSIPeriod,UpDownPeriod);
		
		double curVal = indicator.Value.getRounded(Shift);
		
		return (curVal < Level);
	}

}