package SQ.Blocks.Indicators.DPO;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(DPOAL) DPO is above Level", display=" DPO(@Chart@#Period#) is above #Level#", returnType = ReturnTypes.Boolean)
@OppositeBlock(value="DPOBelowLevel",oscillator=true, middleValue=0,field="Level")
@ParameterSet(set="Period=10")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=80")
@ParameterSet(set="Period=100")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
public class DPOAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="0", minValue=-0.01, maxValue=0.01, step=0.00001)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		DPO indicator = Strategy.Indicators.DPO(Chart, Period);

		double value= indicator.Value.getRounded(Shift,5);
		
		return (value > Level);
	}

}