package SQ.Blocks.Indicators.DVO;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;


@BuildingBlock(name="(DVOBL) DVO is below Level", display="DVO(@Chart@#MAPeriod#,#PercentRankPeriod#) is below #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if DVO is below Level")
@OppositeBlock(value="DVOAboveLevel",oscillator=true,middleValue=50,field="Level")
@ParameterSet(set="MAPeriod=10,PercentRankPeriod=20,Level=25")
@ParameterSet(set="MAPeriod=40,PercentRankPeriod=80,Level=25")
@ParameterSet(set="MAPeriod=80,PercentRankPeriod=160,Level=25")
@ParameterSet(set="MAPeriod=12,PercentRankPeriod=24,Level=25")
@ParameterSet(set="MAPeriod=24,PercentRankPeriod=120,Level=25")
@ParameterSet(set="MAPeriod=120,PercentRankPeriod=240,Level=25")

public class DVOBelowLevel extends ConditionBlock {
	
	@Parameter(defaultChartIndex=0)
	public ChartData Chart;
	
	@Parameter(defaultValue="24", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int MAPeriod;

	@Parameter(defaultValue="120", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int PercentRankPeriod;

	@Parameter(defaultValue="50", isPeriod=false, minValue=0, maxValue=100, step=0.1)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		DVO indicator = Strategy.Indicators.DVO(Chart, MAPeriod,PercentRankPeriod);
		double dvi = indicator.Value.getRounded(Shift);

		
		return (dvi < Level);
	}
}