package SQ.Blocks.Indicators.DidiIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(DIU) Didi Index is UP", display="Didi Index(@Chart@#FastPeriod#,#MediumPeriod#,#SlowPeriod#) is UP", returnType = ReturnTypes.Boolean)
@OppositeBlock(value="DidiIndexDown",oscillator=true, middleValue=1)
public class DidiIndexUp extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="3", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int FastPeriod;

	@Parameter(defaultValue="8", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int MediumPeriod;

	@Parameter(defaultValue="20", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int SlowPeriod;

	@Parameter(name="Method", defaultValue="0")
	@Editor(type=Editors.Selection, values="Simple=0,Exponential=1,Smoothed=2,Linear weighted=3")
	public int MAMethod;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {

		
		DidiIndex indicator = Strategy.Indicators.DidiIndex(Chart, FastPeriod,MediumPeriod,SlowPeriod,MAMethod);
		
		double prevValFast = indicator.FastValue.getRounded(Shift + 1);
		double curValFast = indicator.FastValue.getRounded(Shift);
		double prevValSlow = indicator.SlowValue.getRounded(Shift + 1);
		double curValSlow = indicator.SlowValue.getRounded(Shift);
		
		return (curValFast>curValSlow);
	
	
	
	
	
	
	}

}