package SQ.Blocks.Indicators.EntropyMath;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(ECAL) EntropyMath crosses above Level", display="EntropyMath(@Chart@#EMPeriod#) crosses above #Level#", returnType = ReturnTypes.Boolean)
@OppositeBlock(value="EntropyMathCrossBelowLevel", oscillator=true, middleValue=0, field="Level")
@ParameterSet(set="EMPeriod=10")
@ParameterSet(set="EMPeriod=20")
@ParameterSet(set="EMPeriod=40")
@ParameterSet(set="EMPeriod=100")
@ParameterSet(set="EMPeriod=12")
@ParameterSet(set="EMPeriod=24")
@ParameterSet(set="EMPeriod=48")
@ParameterSet(set="EMPeriod=96")
@ParameterSet(set="EMPeriod=120")
public class EntropyMathCrossAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int EMPeriod;

	@Parameter(defaultValue="0", minValue=-0.009, maxValue=0.009, builderMinValue=-0.009, builderMaxValue=0.009, step=0.00001)
	public double  Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		EntropyMath indicator = Strategy.Indicators.EntropyMath(Chart, EMPeriod);

		double curVvalue = indicator.Value.getRounded(Shift,6);
		double prevVvalue = indicator.Value.getRounded(Shift+1,6);
		
		return (curVvalue > Level)&&(prevVvalue < Level) ;
	}

}