package SQ.Blocks.Indicators.RVI;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(RVIR) RVI is rising", display="RVI(@Chart@#Period#) is rising", returnType = ReturnTypes.Boolean)
@Help("Is triggered if RVI is rising")
@OppositeBlock(value="RVIFalling",oscillator=true, middleValue=0)
@ParameterSet(set="Period=10")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=30")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=50")
@ParameterSet(set="Period=60")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
@ParameterSet(set="Period=100")
public class RVIRising extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		RVI indicator = Strategy.Indicators.RVI(Chart, Period);
		double curVal = indicator.RVI.getRounded(Shift);
		double prevVal = indicator.RVI.getRounded(Shift + 1);
		
		
		return (curVal > prevVal);
	}

}