package SQ.Blocks.Indicators.TTMSqueeze;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(SQMF) TTM Squeeze Momentum is falling", display="TTM Squeeze Momentum is falling(@Chart@#BBPeriod#,#KCPeriod#,#LinRegPeriod#,#MomPeriod#,#BBDeviation#,#NumATRs#)", returnType = ReturnTypes.Boolean)
@Help("Is triggered if TTMSqueeze Momentum is falling 2 bars")
@OppositeBlock("TTM SqueezeMomentumIsRising")

public class TTMSqueezeMomentumIsFalling extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="20", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int BBPeriod;

	@Parameter(defaultValue="20", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int KCPeriod;

	@Parameter(defaultValue="20", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int LinRegPeriod;

	@Parameter(defaultValue="20", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int MomPeriod;

	@Parameter(defaultValue="2", isPeriod=true, minValue=0.1, maxValue=5, step=0.1)
	public double BBDeviation;

	@Parameter(defaultValue="2", isPeriod=true, minValue=0.1, maxValue=5, step=0.1)
	public double NumATRs;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		TTMSqueeze indicator = Strategy.Indicators.TTMSqueeze(Chart, BBPeriod,KCPeriod,LinRegPeriod,MomPeriod,BBDeviation,NumATRs);
		int  squeezeOn = (int)indicator.Squeeze.getRounded(Shift);
		double squeezeMomCur = indicator.SqueezeMomentum.getRounded(Shift);
		double squeezeMomPrev = indicator.SqueezeMomentum.getRounded(Shift+1);
		
		return (squeezeOn == 1 ) & (squeezeMomCur < squeezeMomPrev);
	}

}