/*
 * Copyright (c) 2017-2018, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should.
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include
 * your own code snippet into our standard library please contact us at:
 * https://roadmap.strategyquant.com
 *
 * This code can be used only within StrategyQuant products.
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work
 * with the StrategyQuant community.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */
package SQ.Columns.Databanks;
import java.util.ArrayList; // import the ArrayList class
import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;
import com.strategyquant.tradinglib.ResultsGroup;
import com.strategyquant.tradinglib.ValueTypes;
import com.strategyquant.tradinglib.results.SpecialValues;
import it.unimi.dsi.fastutil.doubles.DoubleArrayList;
import it.unimi.dsi.fastutil.ints.IntArrayList;
import com.strategyquant.lib.L;
import com.strategyquant.lib.SQUtils;
import com.strategyquant.lib.SettingsMap;
import com.strategyquant.tradinglib.CustomCellFormat;
import com.strategyquant.tradinglib.DatabankColumn;
import com.strategyquant.tradinglib.Order;
import com.strategyquant.tradinglib.OrdersList;
import com.strategyquant.tradinglib.ResultsGroup;
import com.strategyquant.tradinglib.SQStats;
import com.strategyquant.tradinglib.StatsTypeCombination;
import com.strategyquant.tradinglib.ValueTypes;
import com.strategyquant.tradinglib.OrderCloseTypes;
import java.util.*; 
import java.util.ArrayList; // import the ArrayList class

public class ExitComplexity extends DatabankColumn {
    
	public ExitComplexity() {
		
		super(L.t("Exit Complexity"), DatabankColumn.Decimal2, ValueTypes.Minimize,0, 0, 50);

		setWidth(100);
		
		// this means that value depends on number of trading days 
		// and has to be normalized by days when comparing with another
		// result with different number of trading days
		///setDependentOnTradingPeriod(true); 
	}
	
	//------------------------------------------------------------------------

	@Override
	public double  compute(SQStats stats, StatsTypeCombination combination, OrdersList ordersList, SettingsMap settings, SQStats statsLong, SQStats statsShort, Result result, SettingsMap rgSpecialValues) throws Exception {
		
		if(ordersList==null || ordersList.isEmpty()) {
			return 0d;
		}

		Set<Byte> byte_Set  = new HashSet<Byte>(); 
		int count =0;
		byte temp =0;
		if(result == null) return 0;
		
		ResultsGroup  rg =  result.getResultsGroup();
	

		if(rg == null) {
            return 0;
        }
		
		
		Result res = rg.subResult(rg.getMainResultKey());

		if(res.getResultKey()==null) fdebug("Complexity","res.getResultKey()> "+res.getResultKey());

        if(res == null) {
            return 0;
        }
		String tf = res.getString(SpecialValues.Timeframe);
        if(tf == null) {
            return 0;
        }
		
		int size = 0;
		if(result == rg.subResult(rg.getMainResultKey())){

		OrdersList filteredOL = rg.orders().filterWithClone(rg.getMainResultKey(), Directions.Both, SampleTypes.FullSample);

		
		for(int i = 0; i<filteredOL.size(); i++) {
				Order order = filteredOL.get(i);
							
				if(order.isBalanceOrder()) {
					continue;
				}
				if(order.isFilledOrder()) {
					/*
					if(order.CloseType!=(byte)14 |order.CloseType!=(byte)4){
						byte_Set.add(order.CloseType);
					}
					*/
				if(order.CloseType==(byte)14) continue;
				if(order.CloseType==(byte)4) continue;
					byte_Set.add(order.CloseType);

					
				}		
			}
			size = 	byte_Set.size();
		}
		return size;
		
		
		
	}

		
	

}	
	