package SQ.Columns.Databanks;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

public class OrderTypeMarket extends DatabankColumn {
    
	public OrderTypeMarket() {
		super("Entry Order Type: Market", 
          DatabankColumn.Decimal2, // value display format
          ValueTypes.Maximize, // whether value should be maximized / minimized / approximated to a value   
          0, // target value if approximation was chosen  
          0, // average minimum of this value
          100); // average maximum of this value
		
    setWidth(80); // defaultcolumn width in pixels
    
		setTooltip("Your tooltip here");  
    

	}
  
  //------------------------------------------------------------------------


	@Override
	public double compute(SQStats stats, StatsTypeCombination combination, OrdersList ordersList, SettingsMap settings, SQStats statsLong, SQStats statsShort) throws Exception {
		if(ordersList==null || ordersList.isEmpty()) {
			return 0d;
		}
		double count = 0;

		for(int i = 0; i<ordersList.size(); i++) {
			Order order = ordersList.get(i);


						
			if(order.isBalanceOrder()) {

				continue;
			}
			if(order.CloseType == (byte)4) {

				continue;
			}
			if(order.isFilledOrder()) {

				if(order.OriginalType == (byte)1 | order.OriginalType == (byte)2){
					count++;
				}
			}
		}
		if(count>0){
			return Math.ceil((count/ordersList.size())*100);
		}
		else return 0;

	}	
	
}